package com.izouma.jiashanxia.repo;

import com.izouma.jiashanxia.domain.User;
import com.izouma.jiashanxia.enums.AuthorityName;
import com.izouma.jiashanxia.security.Authority;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Collections;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest
public class UserRepoTest {
    @Autowired
    private UserRepo userRepo;

    @Test
    public void testUser() {
        User user = User.builder()
                .username("root")
                .password(new BCryptPasswordEncoder().encode("123456"))
                .avatar("")
                .authorities(Collections.singleton(Authority.get(AuthorityName.ROLE_ADMIN)))
                .build();
        userRepo.save(user);
    }

    @Test
    public void createUser() {

        User user = userRepo.findByUsernameAndDelFalse("root");
//        user.setPassword(new BCryptPasswordEncoder().encode("123456"));
        user.setAuthorities(Collections.singleton(Authority.builder().name("ROLE_ADMIN").build()));
        userRepo.save(user);
    }

    @Test
    public void findAllByAuthoritiesContains() {
        List<User> list = userRepo.findAllByAuthoritiesContainsAndDelFalse(Authority.builder().name("ROLE_ADMIN").build());
        System.out.println(list);
    }
}
